classdef GenDataConvertHelper
    %gendataconverthelper provides helper methods for the gendataconvert
    %module
    
    methods(Static)        
        
        function [OutCellArray,Outconfig]=coordinatesHelper(OutCellArray,Inconfig)
            Outconfig=Inconfig;
            
            columnlabels=OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Column Label'),2};
            
            columnlabels=regexp(columnlabels,', ','split');
            
            
            
            columnunits=OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Column unit'),2};
            
            columnunits=regexp(columnunits,', ','split');
            
            
            
            for ii=1:length(columnlabels)
                tcolumnlabels{ii}=['Column ',num2str(ii),': ',columnlabels{ii}];
            end
            
            order=Inconfig{strcmpi(Inconfig, 'Column Order'),2};
            
            ordervec=str2num(order);
            
            if length(columnlabels)==length(ordervec)
                order=GenDataConvertHelper_v4.ArrangeStrings(tcolumnlabels(str2num(order)));
            else
                order=GenDataConvertHelper_v4.ArrangeStrings(tcolumnlabels);
            end
            
            Outconfig{strcmpi(Outconfig, 'Column Order'),2}=num2str(order);
            
            ocolumnlabels=columnlabels{1};
            
            ocolumnunits=columnunits{1};
            
            for ii=2:length(columnlabels)
                ocolumnlabels=[ocolumnlabels,', ',columnlabels{order(ii)}];
                ocolumnunits=[ocolumnunits,', ',columnunits{order(ii)}];
            end
            
            
            
            OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Column Label'),2}=ocolumnlabels;
            
            OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Column unit'),2}=ocolumnunits;
            
            
            
            tdata=OutCellArray{1}.data;
            
            for ii=1:length(columnlabels)
                odata(:,ii)=tdata(:,order(ii));
            end
            
            OutCellArray{1}.data=odata;
        end
        
        function [OutCellArray,Outconfig]=vectormapHelper(OutCellArray,Inconfig)
            Outconfig=Inconfig;
            
            Layerlabels=OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Layer Label'),2};
            
            Layerlabels=regexp(Layerlabels,', ','split');
            
            
            
            Layerunits=OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Layer unit'),2};
            
            Layerunits=regexp(Layerunits,', ','split');
            
            
            
            for ii=1:length(Layerlabels)
                tLayerlabels{ii}=['Layer ',num2str(ii),': ',Layerlabels{ii}];
            end
            
            order=Inconfig{strcmpi(Inconfig, 'Layer Order'),2};
            
            ordervec=str2num(order);
            
            if length(Layerlabels)==length(ordervec)
                order=GenDataConvertHelper_v4.ArrangeStrings(tLayerlabels(str2num(order)));
            else
                order=GenDataConvertHelper_v4.ArrangeStrings(tLayerlabels);
            end
            
            Outconfig{strcmpi(Outconfig, 'Layer Order'),2}=num2str(order);
            
            oLayerlabels=Layerlabels{1};
            
            oLayerunits=Layerunits{1};
            
            for ii=2:length(Layerlabels)
                oLayerlabels=[oLayerlabels,', ',Layerlabels{order(ii)}];
                oLayerunits=[oLayerunits,', ',Layerunits{order(ii)}];
            end
            
            
            
            OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Layer Label'),2}=oLayerlabels;
            
            OutCellArray{1}.header{strcmpi(OutCellArray{1}.header, 'Layer unit'),2}=oLayerunits;
            
            
            
            tdata=OutCellArray{1}.data;
            
            for ii=1:length(Layerlabels)
                odata(:,:,ii)=tdata(:,:,order(ii));
            end
            
            OutCellArray{1}.data=odata;
        end
        
        
        function order=ArrangeStrings(strings)
            indexmax=length(strings);
            
            fig=figure('units','pixels','position',[200,200,430,min(700,46+30*indexmax)],'resize','off', ...
                'menubar','none','name','GenDataConvert_v4 Helper','HandleVisibility','on', ...
                'NumberTitle','off','CloseRequestFcn',@closereq,'WindowButtonDownFcn',@bclick);
            
            movegui(fig,'center');
            
            figpanel=uipanel('parent',fig,'units','pixels','position',[0,0,431,min(700,46+30*indexmax)],'Clipping','on','BorderType','none');
            sliderpanel=uipanel('parent',figpanel,'units','pixels','position',[1,0,400,46+30*indexmax],'BorderType','none');
            
            s=uicontrol('Style','Slider','Parent',fig,'units','pixels','position',[407,10,20,min(700,46+30*indexmax)-20], ...
                'max',max((46+30*indexmax)-700,1),'min',0,'Value',0,'Callback',{@slider_callback1,sliderpanel});
            
            if 700>46+36*indexmax
                set(s,'enable','off');
            end
            
            uicontrol('style','pushbutton','parent',sliderpanel,'units','pixels','position',[165,16,70,22],'string','Ok','callback',@Ok_callback);
            
            function slider_callback1(hObject,~,panelhandel)
                pos=get(hObject,'Value');
                set(panelhandel,'Position',[1,-pos,400,min(700,46+30*indexmax)])
            end
            
            function Ok_callback(~, ~)
                closereq(fig,[]);
            end
            
            for ii=1:indexmax
                p=uipanel('units','pixels','units','pixels','position',[10,46+30*(indexmax-ii),380,26],'parent',sliderpanel,'BorderType','none');
                
                c=uicontrol('style','text','String',strings{ii},'units','pixels','position',[8,2,364,22],'parent',p, ...
                    'fontsize',10,'BackgroundColor','w','enable','inactive');
                
                extent(ii,:)=[18-3,46+30*(indexmax-ii)-2,364+1,22];
                
                handles(ii)=c;
            end
            
            order=1:indexmax;
            
            uiwait(fig);
            
            
            
            function index=getcurrmouseindex(point)
                x=point(1);
                y=point(2);
                
                spos=get(sliderpanel,'Position');
                
                sbottom=spos(2);
                
                textent=extent;
                
                textent(:,2)=textent(:,2)+sbottom;
                
                index=0;
                
                for jj=1:indexmax
                    if x>textent(jj,1)&&x<textent(jj,1)+textent(jj,3)&&y>textent(jj,2)&&y<textent(jj,2)+textent(jj,4)
                        index=jj;
                    end
                end
                
                
            end
            
            
            
            function bclick(~,~)
                cpt=get(fig,'currentpoint');
                
                index=getcurrmouseindex(cpt);
                
                if index~=0
                    spos=get(sliderpanel,'Position');
                    
                    sbottom=spos(2);
                    
                    textent=extent(index,:);
                    
                    textent(2)=textent(2)+sbottom;
                    
                    dragrect(textent);
                    
                    %dragrect(textent-[cpt(1),cpt(2),0,0]);
                    
                    index2=getcurrmouseindex(get(fig,'currentpoint'));
                    
                    t1=strings{index};
                    t2=strings{index2};
                    
                    set(handles(index),'string',t2);
                    set(handles(index2),'string',t1);
                    
                    strings{index}=t2;
                    strings{index2}=t1;
                    
                    o1=order(index);
                    o2=order(index2);
                    
                    order(index)=o2;
                    order(index2)=o1;
                end
            end
            
            
            function closereq(hObject,~)
                delete(hObject);
            end
        end
        
        
        function [OutCellArray,Outconfig]=mapHelper(OutCellArray,Inconfig)
            %MapHelper cleans up a map by removing any unnecessary rows/columns, and
            %setting the background to NaN.  It also squares data, which is a SAGUARO
            %requirement.
            
            %Author: Benjamin Lewis
            
            % Version history:
            % 10/25/11 - Version 3
            
            Outconfig=Inconfig;
            
            tmap=OutCellArray{1}.data;
            
            buttonvalues=str2num(Inconfig{strcmpi(Inconfig, 'MapRadioButtonValues'),2});
            rangeval=str2num(Inconfig{strcmpi(Inconfig, 'Range'),2});
            tol=str2double(Inconfig{strcmpi(Inconfig, 'Tolerance (%)'),2});
            
            fig=figure('Position',[520 628 274 196],'Resize','off','Visible','off', ...
                'Units','pixels','Toolbar','none','MenuBar','none','NumberTitle','off');
            set(fig,'CloseRequestFcn',@Ok_button_Callback);
            set(fig,'Name','Map Helper');
            movegui(fig,'center');
            
            buttongroup1=uibuttongroup('Parent',fig,'units','pixels','Position',[14 45 245 138],'Title',{'Background Replacement'});
            
            radio_none=uicontrol('Style','radiobutton','Position',[14 91 87 23],'String',{'None'},'value',buttonvalues(1),'Parent',buttongroup1);
            radio_auto=uicontrol('Style','radiobutton','Position',[14 55 87 23],'String',{'Auto'},'value',buttonvalues(2),'Parent',buttongroup1);
            radio_range=uicontrol('Style','radiobutton','Position',[14 19 87 23],'String',{'Range'},'value',buttonvalues(3),'Parent',buttongroup1);
            
            tol_edit=uicontrol('Style','edit','Position',[180 55 49 20],'String',{num2str(tol)},'Parent',buttongroup1);
            low_edit=uicontrol('Style','edit','Position',[180 21 49 20],'String',{num2str(rangeval(1))},'Parent',buttongroup1);
            high_edit=uicontrol('Style','edit','Position',[102 21 49 20],'String',{num2str(rangeval(2))},'Parent',buttongroup1);
            
            uicontrol('Style','text','Position',[99 59 75 14],'String',{'Tolerance (%):'},'Parent',buttongroup1);
            uicontrol('Style','text','Position',[161 24 9 14],'String',{'to'},'Parent',buttongroup1);
            
            Ok_button=uicontrol('Position',[105 14 69 22],'string','OK','parent',fig,'callback',{@Ok_button_Callback});
            
            Cancel_button=uicontrol('Position',[184 14 69 22],'string','Cancel','parent',fig,'callback',{@Cancel_button_Callback});
            
            set(fig,'Visible','on');
            
            user_canceled=0;
            
            function Ok_button_Callback(hObject, eventdata, handles)
                buttonvalues(1)=get(radio_none,'value');
                buttonvalues(2)=get(radio_auto,'value');
                buttonvalues(3)=get(radio_range,'value');
                
                nan_range(1)=str2double(get(low_edit,'string'));
                nan_range(2)=str2double(get(high_edit,'string'));
                
                tol=str2double(get(tol_edit,'string'));
                
                delete(fig);
                
                return;
            end
            
            function Cancel_button_Callback(hObject, eventdata, handles)
                delete(fig);
                
                OutCellArray=[];
                
                user_canceled=1;
                
                return;
            end
            
            
            uiwait(fig);
            
            if user_canceled
                return;
            end
            
            Outconfig{strcmpi(Outconfig, 'MapRadioButtonValues'),2}=num2str(buttonvalues,'%u, ');
            
            if buttonvalues(3) %Range
                if any(~isnumeric(nan_range))
                    errordlg('Non numeric input for range!');
                    OutCellArray=[];
                    return;
                end
                
                nan_range=sort(nan_range);
                
                tmap(tmap>=nan_range(1)&tmap<=nan_range(2))=NaN;
                
                Outconfig{strcmpi(Outconfig, 'Range (mm)'),2}=num2str(nan_range,'%e,');
                
            elseif buttonvalues(2) %Auto
                if ~isnumeric(tol)
                    errordlg('Non numeric input for tolerance!');
                    OutCellArray=[];
                    return;
                end
                
                Outconfig{strcmpi(Outconfig, 'Tolerance (%)'),2}=num2str(tol, '%e');
                
                tol=1-tol/100; %convert from percent tolerance to ratio
                
                if length(unique(tmap(~isnan(tmap))))/length(tmap(~isnan(tmap)))<.995 %Identical value is .5% of the map
                    maskval=mode(tmap(~isnan(tmap)));
                else %Else use most populous bin
                    [n,xout]=hist(tmap(~isnan(tmap)),50);
                    maskval=xout(n==max(n));
                end
                
                tmap(tmap>=tol*maskval&tmap<=maskval/tol)=NaN;
                
            else
                %Do nothing
            end
            
            OutCellArray{1}.data=tmap;
        end
    end
end

